"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.baseRequirements = exports.Loader = exports.useRemoteComponents = void 0;
var react_1 = require("react");
var baseRequirements = {
    react: require('react'),
    '@mui/material': require('@mui/material'),
    '@mui/x-date-pickers': require('@mui/x-date-pickers'),
    '@mui/icons-material': require('@mui/icons-material'),
    '@hexhive/ui': require('@hexhive/ui')
};
exports.baseRequirements = baseRequirements;
var Loader = function (base_url, start) { return __awaiter(void 0, void 0, void 0, function () {
    var url, requirementFetch, _initialRequire, _requires, data, stringFunc, exports, module, func;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                url = base_url + start;
                requirementFetch = [];
                _initialRequire = function (name) {
                    if (!(name in baseRequirements)) {
                        requirementFetch.push((function () { return __awaiter(void 0, void 0, void 0, function () {
                            var m_name, m;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        m_name = name;
                                        return [4 /*yield*/, Loader(base_url, name.substring(2, name.length) + '.js')];
                                    case 1:
                                        m = _a.sent();
                                        baseRequirements[m_name] = m;
                                        return [2 /*return*/];
                                }
                            });
                        }); })());
                    }
                };
                _requires = function (name) {
                    if (!(name in baseRequirements)) {
                    }
                    return baseRequirements[name];
                };
                return [4 /*yield*/, fetch(url)];
            case 1:
                data = _a.sent();
                return [4 /*yield*/, data.text()];
            case 2:
                stringFunc = _a.sent();
                exports = {};
                module = { exports: exports };
                func = new Function("require", "module", "exports", stringFunc);
                func(_initialRequire, module, exports);
                return [4 /*yield*/, Promise.all(requirementFetch)];
            case 3:
                _a.sent();
                func(_requires, module, exports);
                return [2 /*return*/, module.exports];
        }
    });
}); };
exports.Loader = Loader;
var useRemoteComponents = function (cache) {
    var _a = cache ? cache : (0, react_1.useState)({}), packs = _a[0], setPacks = _a[1];
    var lock = (0, react_1.useRef)({});
    var getPack = function (id, base_url, url) { return __awaiter(void 0, void 0, void 0, function () {
        var data_1, loader, data_2, e_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(packs[id] || lock.current[id])) return [3 /*break*/, 4];
                    if (!(lock.current[id] instanceof Promise)) return [3 /*break*/, 2];
                    return [4 /*yield*/, lock.current[id]];
                case 1:
                    data_1 = _b.sent();
                    return [2 /*return*/, Object.keys(data_1).map(function (x) { return ({ name: x, component: data_1[x] }); })];
                case 2: return [2 /*return*/, packs[id]];
                case 3: return [3 /*break*/, 7];
                case 4:
                    _b.trys.push([4, 6, , 7]);
                    loader = Loader(base_url, "".concat(url, "?now=").concat(Date.now()));
                    lock.current[id] = loader;
                    return [4 /*yield*/, loader];
                case 5:
                    data_2 = _b.sent();
                    setPacks(__assign(__assign({}, packs), (_a = {}, _a[id] = Object.keys(data_2).map(function (x) { return ({ name: x, component: data_2[x] }); }), _a)));
                    lock.current[id] = undefined;
                    return [2 /*return*/, Object.keys(data_2).map(function (x) { return ({ name: x, component: data_2[x] }); })];
                case 6:
                    e_1 = _b.sent();
                    // console.log({ e, base_url, url })
                    lock.current[id] = undefined;
                    return [3 /*break*/, 7];
                case 7: return [2 /*return*/];
            }
        });
    }); };
    // console.log(RemoteComponent.current instanceof Function, {RemoteComponent: RemoteComponent.current}, typeof(RemoteComponent.current))
    return {
        getPack: getPack
    };
};
exports.useRemoteComponents = useRemoteComponents;
